﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	

	public class Zoomer extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 1;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
			
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0xFFFFFF);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>18){
				counter = 2;
			}else{
				counter++;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = stage.stageWidth/1.5-300;
			my_drawer.y = stage.stageHeight/1.5-230;
			my_drawer.scaleX=my_drawer.scaleY=1.2;
			support.addChild(my_drawer);
			data.draw(support);
			cloned = data.clone();
			var mul:uint = 0x10;
			data.merge(cloned,new Rectangle(0,0,stage.stageWidth,stage.stageHeight),new Point(counter,counter-10),mul,mul,mul,mul);
			
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			//drawer.graphics.beginFill(0xffffff,.05);
			drawer.graphics.lineStyle(6,0x99FF00,100);
			
			drawer.graphics.moveTo(0,0);
		    drawer.graphics.lineTo(0,0);
			drawer.graphics.lineTo(0,300);
            drawer.graphics.lineTo(100,300);
            drawer.graphics.lineTo(100,0);
            drawer.graphics.lineTo(220,0); 
			drawer.graphics.lineTo(220,-80); 
			drawer.graphics.lineTo(100,-80); 
			drawer.graphics.lineTo(100,-200); 
			drawer.graphics.lineTo(0,-200); 
			drawer.graphics.lineTo(0,-80); 
			drawer.graphics.lineTo(-120,-80); 
			drawer.graphics.lineTo(-120,0); 
			drawer.graphics.lineTo(0,0); 
			drawer.graphics.lineTo(0,0); 
					
					
					
			//drawer.graphics.beginFill(0xffffff,.05);
			drawer.graphics.lineStyle(2,0xffffff,0.6);
			
			drawer.graphics.moveTo(0,0);
		    drawer.graphics.lineTo(0,0);
			drawer.graphics.lineTo(0,300);
            drawer.graphics.lineTo(100,300);
            drawer.graphics.lineTo(100,0);
            drawer.graphics.lineTo(220,0); 
			drawer.graphics.lineTo(220,-80); 
			drawer.graphics.lineTo(100,-80); 
			drawer.graphics.lineTo(100,-200); 
			drawer.graphics.lineTo(0,-200); 
			drawer.graphics.lineTo(0,-80); 
			drawer.graphics.lineTo(-120,-80); 
			drawer.graphics.lineTo(-120,0); 
			drawer.graphics.lineTo(0,0); 
			drawer.graphics.lineTo(0,0); 
			
			//drawer.graphics.beginFill(0xffffff,.4);
			drawer.graphics.lineStyle(2,0x99FF66,04);
			drawer.graphics.lineTo(-120,0);
		
			drawer.graphics.lineTo(-30,100);
            drawer.graphics.lineTo(0,100);
            drawer.graphics.lineTo(0,300);
            drawer.graphics.lineTo(90,400); 
			drawer.graphics.lineTo(190,400); 
			drawer.graphics.lineTo(100,300); 
			drawer.graphics.lineTo(190,400); 
			drawer.graphics.lineTo(190,90); 
			drawer.graphics.lineTo(100,0); 
			drawer.graphics.lineTo(190,90); 
			drawer.graphics.lineTo(310,90); 
			drawer.graphics.lineTo(220,0); 
			drawer.graphics.lineTo(310,90);
			drawer.graphics.lineTo(310,10);
			drawer.graphics.lineTo(220,-80);
			drawer.graphics.lineTo(190,-80);
			drawer.graphics.lineTo(190,-110);
			drawer.graphics.lineTo(100,-200);
			//drawer.graphics.beginFill(0xffffff,.05);
			
			
			//drawer.rotation = Math.random()*0;
			return drawer;
		}
		
	}
}